/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.report.web.core.app.view.navigation.ReportTreeParser");

/**
 * Parses the visible report tree nodes.
 */
com.ibm.rational.report.web.core.app.view.navigation.ReportTreeParser = function() {

	this.nodeMap = [];
	this.folderNodes = [];
	
	this.getFolderNodes = function() {
		this.folderNodes = [];
		this.nodeMap = [];
		var domNodes = dojo.query(".folder-widget");
		for(var k=0;k<domNodes.length;k++) {
			var widget = dijit.byId(domNodes[k].id);
			if(widget._folder!=null) {
				var folder = widget._folder;
				this.folderNodes.push(folder);
				this.nodeMap[folder.itemId] = folder;
			}	
		}
	};
	
	this.getNode = function(id) {
		if (id == null) {
			return null;
		}
		return this.nodeMap[id];
	};
	
	this.getValidParents = function(nodeId) {
		this.getFolderNodes();
		if (nodeId == null) {
			return this.folderNodes;
		}
		
		var theNode = this.getNode(nodeId);
		if (theNode == null) {
			return this.folderNodes;
		}
		
		var nodes = [];
		for (var i in this.folderNodes) {
			var node = this.folderNodes[i];
			if (node == theNode) continue;

			var n = null;
			if (node.parent != null) {
				n = this.getNode(node.parent.itemId);
				while(n != null && n.itemId != nodeId) {
					n = n.parent;
					if (n != null) n = this.getNode(n.itemId);
				}
			}
				
			if ((n == null || n.itemId != nodeId) && node.shared == theNode.shared) {
				nodes.push(node);
			}
		}
		
		return nodes;
	};		
	
	this.expandFolder = function(id) {
		var widget = dijit.byId(id);
		if(widget!=null) {
			widget._expand=true;
		}
	};
};
